unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Inifiles, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Label1Click(Sender: TObject);
    procedure Label2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;


var
  Form1: TForm1;

  appINI           : TIniFile;
  FN,Dir           : String;


implementation

{$R *.dfm}

uses SHFolder, shlObj;
// For the form it is necessary to make it auto size otherwise
// the surface height will become to small, (only Delphi, not lazarus)

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Label1.Caption:= TimeToStr(Now);
  label2.Caption:= DateToStr(Now);
end;

procedure TForm1.Label2Click(Sender: TObject);
begin
  BorderStyle := bsNone;
end;


procedure TForm1.Label1Click(Sender: TObject);
begin
  BorderStyle := bsToolWindow;
end;

function GetFolderPath(Wnd: HWnd; CSIDLFolder: Integer): string;
begin
  SetLength(Result, MAX_PATH);
  SHGetFolderPath(Wnd, CSIDLFolder, 0, 0, PChar(Result));
  SetLength(Result, StrLen(PChar(Result)));
  if (Result <> '') then
    Result  := IncludeTrailingBackslash(Result);
end;

function GetShellFolder(CSIDLFolder : integer) : string;
begin
  SetLength(Result, MAX_PATH);
  SHGetSpecialFolderPath(0, PChar(Result), CSIDLFolder, false);
  SetLength(Result, StrLen(PChar(Result)));
  if (Result <> '') then
    Result  := IncludeTrailingBackslash(Result);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Dir:=GetFolderPath(0,CSIDL_LOCAL_APPDATA);
  Label3.Caption:=Dir;
  Label4.Caption:=GetShellFolder(CSIDL_LOCAL_APPDATA);
  Dir:=Dir+ChangeFileExt(ExtractFileName(Application.ExeName),'');
  Label5.Caption:=Dir;
  If not ForceDirectories(Dir) then
    Raise Exception.CreateFmt('Failed to create settings directory %s',[Dir]);
  FN:= Dir+'\'+'appINI.ini';

     appINI := TIniFile.Create(ChangeFileExt(FN,'.ini')) ;
    try
      Top    := appINI.ReadInteger('Placement','Top', Top) ;
      Left   := appINI.ReadInteger('Placement','Left', Left);
      Width  := appINI.ReadInteger('Placement','Width', Width);
      Height := appINI.ReadInteger('Placement','Height', Height);
    finally
      appINI.Free;
    end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  appINI := TIniFile.Create(ChangeFileExt(Fn,'.ini')) ;
  try
  with appINI, Form1 do
    begin
      WriteInteger('Placement','Top', Top) ;
      WriteInteger('Placement','Left', Left) ;
      WriteInteger('Placement','Width', Width) ;
      WriteInteger('Placement','Height', Height) ;
    end;
  finally
    appIni.Free;
  end;
end;

procedure TForm1.FormClick(Sender: TObject);
begin
  // show label 3,4,5
  Label3.Visible := Not Label3.Visible;
  Label4.Visible := Not Label4.Visible;
  Label5.Visible := Not Label5.Visible;
end;

end.
